#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <dzcomm.h>
#include <kb.h>
#include "z80.h"
#include "hardware.h"

void TI8xHelp(void)
{       
        printf("TI-8X emulator %s",VERSION);
        printf("\nby Randy Gluvna");
        printf("\nrandman@home.com");     
        printf("\nhttp://ti8xemu.home.ml.org/");
        printf("\n--------------------------------------------------------------------------------");
        printf("Usage: ti8xemu [calc] [options]");     
        printf("\n--------------------------------------------------------------------------------");
        printf("/bmp <filename>\t\t: use alternate BMP filename for snapshot");
        printf("\n/grey\t\t\t: enable greyscale graphics");
        printf("\n/int <x>\t\t: adjust interrupt timing");
        printf("\n/link <Gx,Px,Sx,K>\t: enable linking (x = port)");
        printf("\n/rom <filename>\t\t: use alternate ROM dump");
        printf("\n/speed <speed>\t\t: adjust speed of emulator (0 = fastest)\n");

        exit(0);
}

void main(int argc,char* argv[])
{          
        char rfilename[256];
        char sfilename[256];
	byte calc;
	int x;

        clrscr();

	Z80_Reset();

        if(argc == 2)
        {
                if(!strcmp("/?",argv[1]))
                        TI8xHelp();
        }

	if(argc == 1)     
                TI8xHelp();                 
        else
        {
		calc = (byte)(atoi(argv[1]));

		if((calc >= 82) && (calc <= 86) && (calc != 84))
		{
			SetCalc(calc);
                        sprintf(sfilename,"DEFAULT.%d",calc);
		}
		else
		{
			for(x = 0; argv[1][x] != '.'; ++x);
			
			calc = (byte)(atoi(argv[1]+x+1));

			if((calc >= 82) && (calc <= 86) && (calc != 84))
			{
				SetCalc(calc);
                                strcpy(sfilename,argv[1]);
			}
			else
			{
				printf("\aInvalid paramaters!\n");
				exit(-1);
			}
		}

                sprintf(rfilename,"ti%d.rom",calc);

                for(x = 2; x <= argc; ++x)
                {
                        if(!strcmp("/?",argv[x]))
                                TI8xHelp();
                        if(!strcmp("/bmp",argv[x]))
                                SetBMP(argv[x+1]);                                
                        if((!strcmp("/grey",argv[x])) || (!strcmp("/gray",argv[x])))
                                SetGrey();
                        if(!strcmp("/int",argv[x]))
                                SetInt(atoi(argv[x+1]));
                        if(!strcmp("/link",argv[x]))
                                SetLink(argv[x+1][0],argv[x+1][1]);
                        if(!strcmp("/rom",argv[x]))
                                strcpy(rfilename,argv[x+1]);
                        if(!strcmp("/speed",argv[x]))
                                SetSpeed(atoi(argv[x+1]));
                }

                for(x = 0; rfilename[x] != NULL; ++x)
                        rfilename[x] = tolower(rfilename[x]);
                for(x = 0; sfilename[x] != NULL; ++x)
                        sfilename[x] = tolower(sfilename[x]);                           

                LoadMEM(rfilename,sfilename);
                InitDisplay();
	}

        kb_install(0);

	Z80();
}
